#include "stm32l_discovery_lcd.h"

// 
GPIO_InitTypeDef    GPIO_InitStructure;
LCD_InitTypeDef     LCD_InitStruct;
ADC_InitTypeDef     ADC_InitStruct;

uint16_t ADC_Data; //     ADC
uint16_t strDisp[6]; //     

// ,     ADC    ASCII 
void convert_into_char(uint32_t number, uint16_t *p_tab);

int main()
{
  //   SYSCLK
  RCC_HSICmd(ENABLE); //   HSI - 16 
  while (RCC_GetFlagStatus(RCC_FLAG_HSIRDY) == RESET); //  HSI
  RCC_SYSCLKConfig(RCC_SYSCLKSource_HSI); // HSI    SYSCLK
  
  //   A, B, C  
  RCC_AHBPeriphClockCmd((RCC_AHBPeriph_GPIOA | RCC_AHBPeriph_GPIOB | RCC_AHBPeriph_GPIOC), ENABLE);
  
  //   A   LCD
  //        LCD
  GPIO_InitStructure.GPIO_Pin = (GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 
                                 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 
                                   | GPIO_Pin_15);
  /*       .
      */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  //  A    
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  /*         LCD.
  GPIO_PinSource1..15   GPIO_Pin_1..15 -  */  
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource1, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource3, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource8, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource15, GPIO_AF_LCD);
  
  //  PA5      ADC
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5; //     ADC
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN; //    PA5
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; //  
  GPIO_Init(GPIOA, &GPIO_InitStructure); //  
  
  /*   B    LCD.   , 
    */
  GPIO_InitStructure.GPIO_Pin = (GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5 
                                 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 
                                   | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 
                                     | GPIO_Pin_14 | GPIO_Pin_15);
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource3, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource4, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource5, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource8, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource9, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource10, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource11, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource12, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource13, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource14, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource15, GPIO_AF_LCD);
  
  //   C    LCD
  GPIO_InitStructure.GPIO_Pin = (GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 
                                 | GPIO_Pin_3 | GPIO_Pin_6 |GPIO_Pin_7 
                                   | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 
                                     | GPIO_Pin_11);
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_Init(GPIOC, &GPIO_InitStructure);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource0, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource1, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource2, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource3, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource6, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource7, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource8, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource9, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource10, GPIO_AF_LCD);
  GPIO_PinAFConfig(GPIOC, GPIO_PinSource11, GPIO_AF_LCD);
  
  // ADC
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE); //  ADC
  ADC_InitStruct.ADC_Resolution = ADC_Resolution_12b;  // ADC - 12 
  ADC_InitStruct.ADC_DataAlign = ADC_DataAlign_Right;  //  
  ADC_Init(ADC1, &ADC_InitStruct);  //  ADC  
  /*      : 
   ADC - ADC1,
    5,
      - 1, 
  sample time - 16 */
  ADC_RegularChannelConfig(ADC1, ADC_Channel_5, 1, ADC_SampleTime_16Cycles);
  ADC_Cmd(ADC1, ENABLE); //  ADC
  while(ADC_GetFlagStatus(ADC1, ADC_FLAG_ADONS) == RESET); //  ADC
  
  //    LCD
  //   LCD  PWR
  RCC_APB1PeriphClockCmd((RCC_APB1Periph_PWR | RCC_APB1Periph_LCD), ENABLE);
  //    RTC
  PWR_RTCAccessCmd(ENABLE);
  //   LSE - 32,768  
  RCC_LSEConfig(RCC_LSE_ON);
  //  
  while (RCC_GetFlagStatus(RCC_FLAG_LSERDY) == RESET);
  //   RTC
  RCC_RTCCLKCmd(ENABLE);
  // LSE     RTC (  LCD)
  RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);
    
  // LCD
  LCD_InitStruct.LCD_Prescaler = LCD_Prescaler_16; //CLKPS = LCDCLK/16
  LCD_InitStruct.LCD_Divider = LCD_Divider_17; //LCD frequency = CLKPS/17
  LCD_InitStruct.LCD_Duty = LCD_Duty_1_4; //1/4 duty
  LCD_InitStruct.LCD_Bias = LCD_Bias_1_3; //1/3 Bias
  //     LCD   step-up 
  LCD_InitStruct.LCD_VoltageSource = LCD_VoltageSource_Internal; 
  LCD_Init(&LCD_InitStruct); // LCD
  
  LCD_MuxSegmentCmd(ENABLE); // "" 
  LCD_ContrastConfig(LCD_Contrast_Level_0); //  
  LCD_WaitForSynchro(); //   LCD_FCR
  LCD_Cmd(ENABLE); //   LCD
  //  step-up    LCD
  LCD_GetFlagStatus(LCD_FLAG_RDY | LCD_FLAG_ENS); 
  /*   LCD .     
     LCD_GLASS_DisplayStrDeci()  -*/
  while(1)
  {
    ADC_SoftwareStartConv(ADC1); // 
    ADC_Data = ADC_GetConversionValue(ADC1); //  
    ADC_Data = ADC_Data*3000/4096; //.  3   
    /*   ADC   .
         1..4*/
    convert_into_char(ADC_Data, strDisp); 
    strDisp[0] = ' '; //    
    strDisp[4] = ' '; //    .    
    strDisp[5] = 'V'; //      V
    strDisp[1] |= DOT; // 
    /*      strDisp.      
             . 
        strDisp[1] |= DOT     */ 
    LCD_GLASS_DisplayStrDeci(strDisp);
  }
}

//     ADC   
void convert_into_char(uint32_t number, uint16_t *p_tab)
{
  uint16_t units=0, tens=0, hundreds=0, thousands=0, misc=0;
  
  units = (((number%10000)%1000)%100)%10;
  tens = ((((number-units)/10)%1000)%100)%10;
  hundreds = (((number-tens-units)/100))%100%10;
  thousands = ((number-hundreds-tens-units)/1000)%10;
  misc = ((number-thousands-hundreds-tens-units)/10000);
  
  *(p_tab+4) = units + 0x30;
  *(p_tab+3) = tens + 0x30;
  *(p_tab+2) = hundreds + 0x30;
  *(p_tab+1) = thousands + 0x30;
  *(p_tab) = misc + 0x30;
}